=== debian/changelog ===
ros-melodic-tf-remapper-cpp (1.1.1-0bionic) bionic; urgency=high

  * Autogenerated, no changelog for this version found in CHANGELOG.rst.

 -- Martin Pecka <peckama2@fel.cvut.cz>  Thu, 07 Mar 2019 14:40:30 -0000
