=== debian/control ===
Source: ros-melodic-tf-remapper-cpp
Section: misc
Priority: extra
Maintainer: Martin Pecka <peckama2@fel.cvut.cz>
Build-Depends: debhelper (>= 9.0.0), ros-melodic-catkin, ros-melodic-roscpp, ros-melodic-rostest, ros-melodic-tf, ros-melodic-tf2-msgs, ros-melodic-xmlrpcpp
Homepage: 
Standards-Version: 3.9.2

Package: ros-melodic-tf-remapper-cpp
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-melodic-roscpp, ros-melodic-tf2-msgs, ros-melodic-xmlrpcpp
Description: More efficient version of tf/tf_remap able to handle TFs at kHz with tens of subscribers.
